# open-session
# 2015-03-18


# initial settings
pluginDir$ = preferencesDirectory$ + "/plugin_PraatSessions"
sessionsDirPref$ = pluginDir$ + "/sessionsDir"


# open session
if fileReadable (sessionsDirPref$)
	sessionsDir$ = readFile$ (sessionsDirPref$)
	sessionlistID = Create Strings as file list: "sessionlist", sessionsDir$
	nSessions = Get number of strings
	if nSessions = 0
		beginPause: "Open session (no sessions)"
			comment: "No sessions available."
			comment: "Your default sessions directory"
			comment: sessionsDir$
			comment: "is empty."
		endPause: "OK", 1, 1
		removeObject: sessionlistID
		exitScript: ()
	endif
	beginPause: "Open session"
		comment: "Choose a session from your default sessions directory."
		optionMenu: "Open session", 1
			for k to nSessions
				selectObject: sessionlistID
				sessionName$ = Get string: k
				basename$ = sessionName$ - ".Collection"
				option: basename$
			endfor
		comment: "If you want the session removed from the harddrive after opening it"
		comment: "check the following box."
		boolean: "Delete session", 0
	clicked = endPause: "Cancel", "Open", 2, 1
	if clicked = 1
		removeObject: sessionlistID
		exitScript ()
	elsif clicked = 2
		selectObject: sessionlistID
		sessionName$ = Get string: open_session
		Read from file: sessionsDir$ + "/" + sessionName$
		# first select, then remove -> selection is empty
		selectObject: sessionlistID
		removeObject: sessionlistID
		if delete_session = 1
			deleteFile: sessionsDir$ + "/" + sessionName$
		endif
	endif
else
	beginPause: "Open session (no default directory)"
		comment: "Couldn't find settings for default sessions directory."
		comment: "Please run [Set sessions directory...] from the Praat menu"
		comment: "and choose a default directory."
	endPause: "OK", 1, 1
	exitScript: ()
endif


