# remove-session
# 2015-03-20


# initial settings
pluginDir$ = preferencesDirectory$ + "/plugin_PraatSessions"
sessionsDirPref$ = pluginDir$ + "/sessionsDir"


# some tests
if fileReadable (sessionsDirPref$)
	sessionsDir$ = readFile$ (sessionsDirPref$)
	sessionlistID = Create Strings as directory list: "sessionlist", sessionsDir$
	nSessions = Get number of strings
	if nSessions = 0
		beginPause: "Remove session (no sessions)"
			comment: "No sessions available."
			comment: "Your default sessions directory"
			comment: sessionsDir$
			comment: "is empty."
		endPause: "OK", 1, 1
		removeObject: sessionlistID
		exitScript: ()
	endif
else
	beginPause: "Remove session (no default directory)"
		comment: "Couldn't find settings for default sessions directory."
		comment: "Please run [Set sessions directory...] from the Praat menu"
		comment: "and choose a default directory."
	endPause: "OK", 1, 1
	exitScript: ()
endif


# remove session(s)
beginPause: "Remove session"
	comment: sessionsDir$ + " contains " + string$ (nSessions) + " sessions."
	optionMenu: "Remove session", 1
	for k to nSessions
		selectObject: sessionlistID
		sessionName$ = Get string: k
		basename$ = sessionName$ - ".Collection"
		# query disk usage of sessions (only mac and linux)
		if macintosh=1 || unix=1
			@calcSize: sessionsDir$
			option: basename$ + " ("  + size$ + ")"
		else
			option: basename$
		endif
	endfor
	boolean: "Remove all sessions", 0
clicked = endPause: "Cancel", "Remove", 2, 1
if clicked = 1
	nocheck removeObject: sessionlistID
	exitScript ()
elsif clicked = 2
	if remove_all_sessions = 1
		beginPause: "Confirmation"
			comment: "Everything in" 
			comment: sessionsDir$
			comment: "will be removed."
			comment: "You can't undo!"
			comment: "Are you sure?"
		cclicked = endPause: "Cancel", "I'am sure", 2, 1
		if cclicked = 1
			nocheck removeObject: sessionlistID
			exitScript ()
		elsif cclicked = 2
			for i to nSessions
				@removeSession: i
			endfor
		endif
	else
		@removeSession: remove_session
	endif
endif

nocheck removeObject: sessionlistID


procedure removeSession: .sessionIndex
	selectObject: sessionlistID
	.sessionName$ = Get string: .sessionIndex
	deleteFile: sessionsDir$ + "/" + .sessionName$
endproc


procedure calcSize: .targetDir$
	.tmpFile$ = temporaryDirectory$ + "du"
	runSystem: "cd """ + .targetDir$ + """ && du -h | tail -n 1 | cut -f 1 > " + .tmpFile$
	size$ = readFile$ (.tmpFile$)
	runSystem: "rm " + .tmpFile$
endproc


